
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

class ImagePanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private Image img;

	public ImagePanel(int width, int height) {
		img = new BufferedImage(width, height, BufferedImage.TYPE_BYTE_INDEXED);
		Dimension size = new Dimension(img.getWidth(null), img.getHeight(null));
		setPreferredSize(size);
		setMinimumSize(size);
		setMaximumSize(size);
		setLayout(null);
	}
	public Image getImage(){
		return img;
	}
	public void setImage(Image im){
		img=im;
	}
	public void paintComponent(Graphics g) {
		g.drawImage(img.getScaledInstance(500, 300, Image.SCALE_FAST), 0, 0, null);
	}
}

