

public class RESNeuron extends Neuron {
	private static final long serialVersionUID = 1L;

	public RESNeuron(int id, double activationLvl, Layer parentLayer, Settings z) {
		super(id, activationLvl, parentLayer, z);
		
		// RES values.
		a = 0.1;
		b = 0.26;
		c = -70;
		d = 2.0;			
		v = c; 
		u = 0;
	}
}
