

public class RSNeuron extends Neuron {
	private static final long serialVersionUID = 1L;

	public RSNeuron(int id, double activationLvl,
			Layer parentLayer, Settings z) {
		super(id, activationLvl, parentLayer, z);

		// RS values
		a = 0.2;
		b = 0.1;
		c = -70;
		d = 8.0;
		
		v = c; 
		u = 0;
	}
}
