import java.io.Serializable;

public class Settings implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String name;
	/* Misc */
	//many values will be changed by the gui settings
	private int timesteps = 2000;
	private int deltaT=10;
	private boolean showFiringChart=false;
	private boolean showFiringRateChart=true;
	private boolean diplayAverageGraph=false;
	private boolean displayInhibitoryGraph=true;
	private int defaultFPS=100;
	private int activityStep = 5;
	private int activityContrast = 20;
	private int numberOfThreads = 8;
	private int weightUpdateRate = 10;
	private double Esyn = 0.0;
	private double Esyn_inhibitory = -70.0;
	private int tettaSyn = 10;
	private int tettaSynINH = 10;
	private int defaultTetta = 20;
	private double initActivationLvl=30;
	private int initLayerWeight=10;
	private double inputLayerInitExWeight=1; //WEIGHT
	private int inputLayerSynapsesPrNeuron=1;
	private int inputLayerTetta = 20;
	private int inputLayerDelay=1;
	private  double alfa = 0.8;
	private  int betta = 1;
	private String topologyFile="";
	private MyForceC controller;
	private double goalPosX = 0;
	private double goalPosY = 0;
	private double goalPosZ = 0;
	private boolean randomInput=false;
	private double asyn4;
	private double asyn4_3;
	private double asyn3;
	private double asyn3_5;
	private double asyn7_4;
	private double asyn8_5;
	private double asyn9_6;
	private double asyn5_3;
	private double asyn5_4;
	private double asyn3_6;
	private double asyn3_1;
	private double asyn6_3;
	private double asyn6_4;
	private double randomBurst = 0;
	private int internalDelay=0;
	private double weightFactor=500;
	private int interLayerDelay;
	private double learningConstant=1;
	private double STDPLearningConstant=1;
	private double forgettingConstant=0;
	private double lastTwoSpikerateConstant=0;
	private double spikeRateAlfa=0;
	private int spikeRateType=0;
	private int startUpdateWeights=0;
	private boolean useEvents=false;
	private double minChangeEvent=0;
	private double spikeRateAlfaNow=0;
	private double spikeRateAlfaPrev=0;
	private int SRWindowL1=2000;
	private int SRWindowL2=1000;
	private int SRWindowInterval=1500;
	private int SRWindowL1P;
	private int SRWindowL2P;
	private int SRWindowIntervalP;
	private int SRWindowL1H;
	private int SRWindowL2H;
	private int SRWindowIntervalH;
	private double timeTheta=0.001;
	private double needA=8;
	private int needB=7;

	public double getGoalPosX() {
		return goalPosX;
	}
	public double getGoalPosY() {
		return goalPosY;
	}
	public double getGoalPosZ() {
		return goalPosZ;
	}
	public void setGoalPosX(double goalPosX) {
		this.goalPosX = goalPosX;
	}
	public void setGoalPosY(double goalPosY) {
		this.goalPosY = goalPosY;
	}
	public void setGoalPosZ(double goalPosZ) {
		this.goalPosZ = goalPosZ;
	}
	public MyForceC getController() {
		return controller;
	}
	public void setController(MyForceC controller) {
		this.controller = controller;
	}
	public String getTopologyFile() {
		return topologyFile;
	}
	public void setTopologyFile(String topologyFile) {
		this.topologyFile = topologyFile;
	}
	public Settings(String name) {
		this.name = name;
	}
	public double getAlfa() {
		return alfa;
	}
	public void setAlfa(double alfa) {
		this.alfa = alfa;
	}
	public int getBetta() {
		return betta;
	}
	public void setBetta(int betta) {
		this.betta = betta;
	}
	public int getTimesteps() {
		return timesteps;
	}
	public void setTimesteps(int timesteps) {
		this.timesteps = timesteps;
	}
	public int getDeltaT() {
		return deltaT;
	}
	public void setDeltaT(int deltaT) {
		this.deltaT = deltaT;
	}
	public boolean isShowFiringChart() {
		return showFiringChart;
	}
	public void setShowFiringChart(boolean showFiringChart) {
		this.showFiringChart = showFiringChart;
	}
	public int getDefaultFPS() {
		return defaultFPS;
	}
	public void setDefaultFPS(int defaultFPS) {
		this.defaultFPS = defaultFPS;
	}
	public int getActivityStep() {
		return activityStep;
	}
	public void setActivityStep(int activityStep) {
		this.activityStep = activityStep;
	}
	public int getActivityContrast() {
		return activityContrast;
	}
	public void setActivityContrast(int activityContrast) {
		this.activityContrast = activityContrast;
	}
	public int getNumberOfThreads() {
		return numberOfThreads;
	}
	public void setNumberOfThreads(int numberOfThreads) {
		this.numberOfThreads = numberOfThreads;
	}
	public int getWeightUpdateRate() {
		return weightUpdateRate;
	}
	public void setWeightUpdateRate(int weightUpdateRatio) {
		this.weightUpdateRate = weightUpdateRatio;
	}
	public double getEsyn() {
		return Esyn;
	}
	public void setEsyn(double esyn) {
		Esyn = esyn;
	}
	public double getEsyn_inhibitory() {
		return Esyn_inhibitory;
	}
	public void setEsyn_inhibitory(double esyn_inhibitory) {
		Esyn_inhibitory = esyn_inhibitory;
	}
	public int getTettaSyn() {
		return tettaSyn;
	}
	public int getTettaSynINH() {
		return tettaSynINH;
	}
	public void setTettaSynINH(int tettaSynINH) {
		this.tettaSynINH = tettaSynINH;
	}
	public int getDefaultTetta() {
		return defaultTetta;
	}
	public void setDefaultTetta(int defaultTetta) {
		this.defaultTetta = defaultTetta;
	}
	public double getInitActivationLvl() {
		return initActivationLvl;
	}
	public void setInitActivationLvl(double initActivationLvl) {
		this.initActivationLvl = initActivationLvl;
	}
	public int getInitLayerWeight() {
		return initLayerWeight;
	}
	public void setInitLayerWeight(int initLayerWeight) {
		this.initLayerWeight = initLayerWeight;
	}
	public double getInputLayerInitExWeight() {
		return inputLayerInitExWeight;
	}
	public void setInputLayerInitExWeight(double inputLayerInitExWeight) {
		this.inputLayerInitExWeight = inputLayerInitExWeight;
	}
	public int getInputLayerSynapsesPrNeuron() {
		return inputLayerSynapsesPrNeuron;
	}
	public void setInputLayerSynapsesPrNeuron(int inputLayerSynapsesPrNeuron) {
		this.inputLayerSynapsesPrNeuron = inputLayerSynapsesPrNeuron;
	}
	public int getInputLayerTetta() {
		return inputLayerTetta;
	}
	public void setInputLayerTetta(int inputLayerTetta) {
		this.inputLayerTetta = inputLayerTetta;
	}
	public int getInputLayerDelay() {
		return inputLayerDelay;
	}
	public void setInputLayerDelay(int inputLayerDelay) {
		this.inputLayerDelay = inputLayerDelay;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public boolean isShowFiringRateChart() {
		return showFiringRateChart;
	}
	public void setShowFiringRateChart(boolean showFiringRateChart) {
		this.showFiringRateChart = showFiringRateChart;
	}
	public boolean getDisplayAverageGraph() {
		return diplayAverageGraph;
	}
	public void setDisplayAverageGraph(boolean selected) {
		diplayAverageGraph=selected;
	}
	public boolean getDisplayInhibitoryGraph(){
		return displayInhibitoryGraph;
	}
	public void setDisplayInhibitoryGraph(boolean selected) {
		displayInhibitoryGraph=selected;
	}
	public boolean getRandomInput() {
		return randomInput;
	}
	public void setRandomInput(boolean randomInput) {
		this.randomInput = randomInput;
	}
	public void setAsyn4(double asyn4) {
		this.asyn4=asyn4;	
	}
	public double getAsyn4() {
		return asyn4;
	}
	public double getAsyn3() {
		return asyn3;
	}
	public double getAsyn3_5() {
		return asyn3_5;
	}
	public double getAsyn5_3() {
		return asyn5_3;
	}
	public double getAsyn7_4() {
		return asyn7_4;
	}
	public double getAsyn8_5() {
		return asyn8_5;
	}
	public double getAsyn9_6() {
		return asyn9_6;
	}
	public double getAsyn3_6() {
		return asyn3_6;
	}
	public void setAsyn3(double parseDouble) {
		asyn3=parseDouble;		
	}
	public void setAsyn3_5(double parseDouble) {
		asyn3_5=parseDouble;	
	}
	public void setAsyn7_4(double parseDouble) {
		asyn7_4=parseDouble;		
	}
	public void setAsyn8_5(double parseDouble) {
		asyn8_5=parseDouble;		
	}
	public void setAsyn9_6(double parseDouble) {
		asyn9_6=parseDouble;	
	}
	public void setAsyn5_3(double parseDouble) {
		asyn5_3=parseDouble;
	}
	public void setAsyn3_6(double parseDouble) {
		asyn3_6=parseDouble;	
	}
	public void setAsyn3_1(double parseDouble) {
		asyn3_1=parseDouble;
	}
	public double getAsyn3_1() {
		return asyn3_1;
	}
	public double getAsyn6_3() {
		return asyn6_3;
	}
	public void setAsyn6_3(double asyn6_3) {
		this.asyn6_3 = asyn6_3;
	}
	public void setRandomBurst(double d) {
		randomBurst =d;	
	}
	public double getRandomBursting() {
		return randomBurst;
	}
	public int getInternalDelay() {
		return internalDelay;
	}
	public void setInternalDelay(int d) {
		this.internalDelay = d;
	}
	public void setInterLayerDelay(int interLayerDelay) {
		this.interLayerDelay = interLayerDelay;
	}
	public int getInterLayerDelay(){
		return interLayerDelay;
	}
	public void setWeightFactor(double parseDouble) {
		weightFactor=parseDouble;
	}
	public double getWeightFactor() {
		return weightFactor;
	}
	public void setLearningConstant(double parseDouble) {
		learningConstant=parseDouble;
	}
	public double getLearningConstant() {
		return learningConstant;
	}
	public void setAsyn5_4(double parseDouble) {
			asyn5_4=parseDouble;		
	}
	public double getAsyn5_4() {
		return asyn5_4;
	}
	public void setAsyn6_4(double asyn6_4) {
		this.asyn6_4 = asyn6_4;
	}
	public double getAsyn6_4() {
		return asyn6_4;
	}
	public double getSTDPLearningConstant() {
		return STDPLearningConstant;
	}
	public void setSTDPLearningConstant(double sTDPLearningConstant) {
		STDPLearningConstant = sTDPLearningConstant;
	}
	public double getForgettingConstant() {
		return forgettingConstant;
	}
	public void setForgettingConstant(double forgettingConstant) {
		this.forgettingConstant = forgettingConstant;
	}
	public double getLastTwoSpikerateConstant() {
		return lastTwoSpikerateConstant;
	}
	public void setLastTwoSpikerateConstant(double lastTwoSpikerateConstant) {
		this.lastTwoSpikerateConstant = lastTwoSpikerateConstant;
	}
	public void setSpikerateAlfa(double parseDouble) {
		spikeRateAlfa=parseDouble;	
	}
	public double getSpikeRateAlfa() {
		return spikeRateAlfa;
	}
	public void setSpikerateType(int selectedIndex) {
		spikeRateType=selectedIndex;	
	}
	public int getSpikeRateType() {
		return spikeRateType;
	}
	public void setAsyn4_3(double parseDouble) {
		asyn4_3 = parseDouble;
	}
	public double getAsyn4_3() {
		return asyn4_3;
	}
	public void setStartUpdateWeights(int parseInt) {
		startUpdateWeights=parseInt;
	}
	public int getStartUpdateWeights() {
		return startUpdateWeights;
	}
	public void setUseEvents(boolean selected) {
		useEvents= selected;	
	}
	public boolean getUseEvents(){
		return useEvents;
	}
	public void setMinChangeEvent(double parseDouble) {
		minChangeEvent=parseDouble;	
	}
	public double getMinChangeEvent() {
		return minChangeEvent;
	}
	public void setSpikerateAlfaNow(double parseDouble) {
		spikeRateAlfaNow=parseDouble;	
	}
	public void setSpikerateAlfaPrev(double parseDouble) {
		spikeRateAlfaPrev=parseDouble;
	}
	public double getSpikeRateAlfaNow() {
		return spikeRateAlfaNow;
	}
	public double getSpikeRateAlfaPrev() {
		return spikeRateAlfaPrev;
	}
	public void setSRWindowL1(int parseDouble) {
		SRWindowL1=parseDouble;	
	}
	public int getSRWindowL1() {
		return SRWindowL1;
	}
	public void setSRWindowL2(int sRWindowL2) {
		SRWindowL2 = sRWindowL2;
	}
	public int getSRWindowL2() {
		return SRWindowL2;
	}
	public void setSRWindowInterval(int sRWindowInterval) {
		SRWindowInterval = sRWindowInterval;
	}
	public int getSRWindowInterval() {
		return SRWindowInterval;
	}
	public void setSRWindowL1P(int parseInt) {
		SRWindowL1P= parseInt;	
	}
	public int getSRWindowL2P() {
		return SRWindowL2P;
	}
	public void setSRWindowL2P(int sRWindowL2P) {
		SRWindowL2P = sRWindowL2P;
	}
	public int getSRWindowIntervalP() {
		return SRWindowIntervalP;
	}
	public void setSRWindowIntervalP(int sRWindowIntervalP) {
		SRWindowIntervalP = sRWindowIntervalP;
	}
	public int getSRWindowL1H() {
		return SRWindowL1H;
	}
	public void setSRWindowL1H(int sRWindowL1H) {
		SRWindowL1H = sRWindowL1H;
	}
	public int getSRWindowL2H() {
		return SRWindowL2H;
	}
	public void setSRWindowL2H(int sRWindowL2H) {
		SRWindowL2H = sRWindowL2H;
	}
	public int getSRWindowIntervalH() {
		return SRWindowIntervalH;
	}
	public void setSRWindowIntervalH(int sRWindowIntervalH) {
		SRWindowIntervalH = sRWindowIntervalH;
	}
	public int getSRWindowL1P() {
		return SRWindowL1P;
	}
	public double getTimeTheta() {
		return timeTheta;
	}
	public void setTimeTheta(double timeTheta) {
		this.timeTheta = timeTheta;
	}
	public void setNeedA(double parseDouble) {
		needA=parseDouble;
	}
	public void setNeedB(int parseDouble) {
		needB=parseDouble;	
	}
	public double getNeedA() {
		return needA;
	}
	public int getNeedB() {
		return needB;
	}
}
