import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class Globals {

	//Spikerate type:
	
	public static final int SPLIT_WINDOW = 3;

	public static boolean firstTime=true;
		
	public static ArrayList<double[]> rsNeuronRecovery = new ArrayList<double[]>();
	public static ArrayList<double[]> rsNeuronActivation = new ArrayList<double[]>();

	public static int runNumber = 0;
	
	// Default neuron variables
	public static double A = 0.02;
	public static double B = 0.2;
	public static double C = -65.0;
	public static double D = 8.0;
	
	// Plotting
	public static ArrayList<int[]> AvgAllFiringsRS=new ArrayList<int[]>();
	public static ArrayList<int[]> AvgAllFiringsRES=new ArrayList<int[]>();
	public static ArrayList<int[]> AvgAllFiringsINH=new ArrayList<int[]>();
	public static ArrayList<int[]> AvgAllFiringsINP = new ArrayList<int[]>();
	
	public static double realNrRSNeuron=0;
	public static double realNrRESNeuron=0;
	public static double realNrINHNeuron=0;
	public static double realNrINPNeuron=0;
	
	public static boolean runInProgress=false;

	public static double[] MembranePotential=new double[5000];

	public static double maxSigmoidSpikeRate = 34.1425;
	
	
	public static int[] readFile(String url)  {
		
		FileReader fileReader;
		BufferedReader bufferedReader;
		String s="";
		
		try {
			fileReader = new FileReader(url);
		
			bufferedReader = new BufferedReader(fileReader);
			s = bufferedReader.readLine();
			fileReader.close();
		
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		int res[]=new int[s.length()];
		for(int i=0;i<s.length();i++){
			res[i]=Integer.parseInt(Character.toString(s.charAt(i)));
		}
		return res;
	}
	
}
