import java.beans.XMLEncoder;
import java.io.*;


public class SettingsReader {

	public SettingsReader() {
		
	}
	public void writeSettings(Settings s, String location) throws IOException, ClassNotFoundException {
		ObjectOutputStream outputStream = null;
		outputStream = new ObjectOutputStream(new FileOutputStream(location));
		outputStream.writeObject(s);
	}
	public Settings readSettings(String location) throws IOException, ClassNotFoundException {
		ObjectInputStream inputStream = null;
		inputStream = new ObjectInputStream(new FileInputStream(location));
		return (Settings)inputStream.readObject();
	}
	public Settings readXMLFile(String location) throws IOException, ClassNotFoundException {
		FileInputStream fis = new FileInputStream(location);
		ObjectInputStream ois = new ObjectInputStream(fis);
		return (Settings) ois.readObject();
	}
	public void writeXMLFile(Settings z, String location) throws IOException, ClassNotFoundException {
		FileOutputStream outputStream = null;
		outputStream = new FileOutputStream(location);
		// Create XML encoder.
		XMLEncoder encoder = new XMLEncoder(outputStream);
		// Write object.
		encoder.writeObject(z);
	}
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		SettingsReader reader = new SettingsReader();
		Settings z = reader.readSettings("TestSettings.txt");
		z.setActivityStep(10);
		reader.writeSettings(z, z.getName()+"_copy.txt");
	}
}